HDU 1058 Humble Numbers(dp)

Problem Description

A number whose only prime factors are 2,3,5 or 7 is called a humble number. The sequence 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12, 14, 15, 16, 18, 20, 21, 24, 25, 27, ... shows the first 20 humble numbers.

Write a program to find and print the nth element in this sequence

Input

The input consists of one or more test cases. Each test case consists of one integer n with 1 <= n <= 5842. Input is terminated by a value of zero (0) for n.

Output

For each test case, print one line saying "The nth humble number is number.". Depending on the value of n, the correct suffix "st", "nd", "rd", or "th" for the ordinal number nth has to be used like it is shown in the sample output.

Sample Input

1
2
3
4
11
12
13
21
22
23
100
1000
5842
0

Sample Output

The 1st humble number is 1.
The 2nd humble number is 2.
The 3rd humble number is 3.
The 4th humble number is 4.
The 11th humble number is 12.
The 12th humble number is 14.
The 13th humble number is 15.
The 21st humble number is 28.
The 22nd humble number is 30.
The 23rd humble number is 32.
The 100th humble number is 450.
The 1000th humble number is 385875.
The 5842nd humble number is 2000000000.

Source

University of Ulm Local Contest 1996

Recommend

JGShining   |   We have carefully selected several similar problems for you:  1003 1069 1176 2084 1024

#include<iostream>
#include<cstring>
#include<algorithm>
#include<cstdio>
#include<queue>
#include<stack>
using namespace std;

#define N 5843

int a[N],c[4];

int main()
{
	int i,j;
	int x,y,z,w;
	x=y=w=z=1;
	a[0]=1;
	int temp;
	for(i=1;i<N;i++)
	{
		 c[0]=a[x-1]*2;
		 c[1]=a[y-1]*3;
		 c[2]=a[z-1]*5;
		 c[3]=a[w-1]*7;

		 temp=c[0];

		 for(j=1;j<4;j++)
			if(c[j]<temp)
			  temp=c[j];

		 if(c[0]==temp)
			x++;

		if(c[1]==temp)
			y++;

		if(c[2]==temp)
			z++;

		if(c[3]==temp)
			w++;

		a[i]=temp;
	}

		int n;
		while(~scanf("%d",&n),n)
		{
			if(n%10==1&&n%100!=11)
				printf("The %dst humble number is %d.\n",n,a[n-1]);
			else
				if(n%10==2&&n%100!=12)
				printf("The %dnd humble number is %d.\n",n,a[n-1]);
			else
				if(n%10==3&&n%100!=13)
				printf("The %drd humble number is %d.\n",n,a[n-1]);
			else
				printf("The %dth humble number is %d.\n",n,a[n-1]);
		}

    return 0;
}
时间: 2024-08-01 17:21:21

HDU 1058 Humble Numbers(dp)的相关文章

HDU 1058 Humble Numbers(DP,数)

题意  所有只能被2,3,5,7这4个素数整除的数称为Humble Number  输入n  输出第n个Humble Number 1是第一个humble number  对于一个Humble Number  a  有2*a,3*a,5*a,7*a都是Humble Number  可以以1为基数  依次展开即可得到一定范围内的Humble Number 用i,j,k,l分别记录 2,3,5,7分别乘到了第几个Humble Number  当前在计算第cnt个Humble Number  那么有

HDU 1058 Humble Numbers (打表)

题目链接:HDU 1058 Humble Numbers 题意:一些数他们的素数因子只有2,3,5,7.求这些数. 因为这些数的因子只可能是2,3,5,7.所以通过2,3,5,7这个四个数构造这个数列,这个数列靠后的数必定是前面的数乘上2,3,5,7得到. AC代码: #include<stdio.h> #include<set> #define ll __int64 using namespace std; set<ll> s; set<ll>::iter

HDU Humble Numbers (dp)

Humble Numbers Time Limit : 2000/1000ms (Java/Other)   Memory Limit : 65536/32768K (Java/Other) Total Submission(s) : 8   Accepted Submission(s) : 4 Font: Times New Roman | Verdana | Georgia Font Size: ← → Problem Description A number whose only prim

HDU 1058 Humble Numbers(递推)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1058 题意:丑数是指只有2,3,5 or 7这几个素因数的数(所以1也是丑数),找到第n个丑数. 思路:除了2,3,5,7任何一个丑数都是由另一个丑数乘上2,或3,或5,或7得到的. 所以可以用优先队列,每取出一个丑数就入队他们乘上2,3,5,7得到的四个丑数,这样每个丑数都生成了.复杂度还是不错的,不过按这种方法会生成比较大的数,最终爆掉int,所以要用long long //93MS 1228K

HDU 1058 Humble Numbers(离线打表)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1058 解题报告:输入一个n,输出第n个质因子只有2,3,5,7的数. 用了离线打表,因为n最大只有5842. 1 #include<stdio.h> 2 #define INT __int64 3 INT ans[5850] = { 4 0,1,2,3,4,5,6,7,8,9,10,12,14,15,16,18,20,21,24,25,27,28,30,32,35,36,40,42,45,48,4

hdu 1058 Humble Numbers(构造?枚举?)

题意: 一个数的质因子如果只是2,3,5,7中的若干个.则这个数叫做humble number. 例如:1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12, 14, 15, 16, 18, 20, 21, 24, 25, 27, ... 给n,问第n个humble number是多少. 思路: 所有的humble数的构造都是:(2^a)*(3^b)*(5^c)*(7^d).a,b,c,d大于等于0. X=a+b+c+d代表这个数是第X个humble数. 假设前i-1个humble

hdu 1058 Humble Numbers【dp】

题目链接:http://acm.acmcoder.com/showproblem.php?pid=1058 题意:数字只有2,3,5,7素因子的数叫做Humble Number,问你第 n 个Humble Number是什么? 解法:枚举. 代码: #include <stdio.h> #include <string.h> #include <vector> #include <string> #include <algorithm> #inc

HDU 1058 Humble Numbers (dp+打表)

先是想筛法素数表啊,然后1~2000000000枚举打表啊,结果越想越不对. 后来想到唯一分解定理,可是怎么实现呢..果然还是需要努力啊.. 研究了discuss代码,码之~ ~~~~ dp的思想,若dp[i]是Humble Numbers,那么dp[i]*2,dp[i]*3,dp[i]*5,dp[i]*7都将是Humble Numbers. 所以只需要注意连续性便好了. #include<cstdio> #include<algorithm> #include<cmath&

HDU 1260:Tickets(DP)

Tickets Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 923    Accepted Submission(s): 467 Problem Description Jesus, what a great movie! Thousands of people are rushing to the cinema. However,